{
    Respond, the fax number form daemon
    Copyright (C) 2000 Horst F <horstf@gmx.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit ObservedStringList;

interface
  uses
    Classes, Observer;

  type
    {
      This class replaces the original TStringList to observe creating and
      destroying string lists. It does nothing except to register the new
      string list on create with the observer and unregister it on destroy.
    }
    TObservedStringList = class(TStringList)
    public
      constructor Create;
      destructor Destroy; override;
    end;

implementation

  {
    Creates the string list and registers with the observer.
  }
  constructor TObservedStringList.Create;
  begin
    inherited Create;
    ObjectObserver.Observe(self);
  end;

  {
    Unregisters from observer and destroys the string list.
  }
  destructor TObservedStringList.Destroy;
  begin
    ObjectObserver.Forget(self);
    inherited Destroy;
  end;

end.
