{
    Respond, the fax number form daemon
    Copyright (C) 2000 Horst F <horstf@gmx.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit Respfrm;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DWinSock, Buttons, PhBook, Header,
  ExtCtrls, Histfrm, Morefrm, CommonDataAccess;

type
  TMainForm = class(TForm)
    Eingabe: TEdit;
    FaxLabel: TLabel;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Nutzer: TEdit;
    NutzerLabel: TLabel;
    Empfaenger: TEdit;
    EmpfaengerLabel: TLabel;
    Name: TEdit;
    Namelabel: TLabel;
    EmpfaengerKopf: TLabel;
    AbsenderKopf: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    DelayedLabel: TLabel;
    DelayedEdit: TEdit;
    DelayedCheck: TCheckBox;
    BTList: TSpeedButton;
    MoreBtn: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure EingabeKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BTListClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MoreBtnClick(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure ExecuteHistory;
    procedure ReadLabels;
    procedure ActivateControls;
  public
    { Public-Deklarationen }
    Delayed : TDelayed;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  ReadLabels;   { Set labels }
  ActivateControls;  { Enable controls if required }
end;

procedure TMainForm.EingabeKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if ( Shift = [] ) and ( Key = VK_DOWN ) then ExecuteHistory;
end;

procedure TMainForm.BTListClick(Sender: TObject);
begin
  ExecuteHistory;
end;

procedure TMainForm.ExecuteHistory;
var
  number, receiver : String;
begin
  HistForm := THistForm.Create(Self);
  if HistForm.ShowModal = IDOK then begin
    HistForm.GetSelectedItem(number, receiver);
    if number <> '' then begin
      if Eingabe.Text = '' then begin
        Empfaenger.Text := receiver;
      end else begin
        Empfaenger.Text := '';
      end;
      Eingabe.Text := Eingabe.Text + ' ' + number;
    end;
  end;
  HistForm.Free;
end;

procedure TMainForm.ReadLabels;
{ Labels aus WIN.INI lesen }
begin
  EmpfaengerKopf.Caption := GetLabelStr(KIReceiver);
  FaxLabel.Caption := GetLabelStr(KIFaxNums);
  EmpfaengerLabel.Caption := GetLabelStr(KIRecvName);
  AbsenderKopf.Caption := GetLabelStr(KISender);
  NutzerLabel.Caption := GetLabelStr(KIUser);
  NameLabel.Caption := GetLabelStr(KISendName);
  OKBtn.Caption := GetLabelStr(KIOK);
  CancelBtn.Caption := GetLabelStr(KICancel);
  DelayedCheck.Caption := GetLabelStr(KIDelayed);
  DelayedLabel.Caption := GetLabelStr(KIDelayed);
  MoreBtn.Caption := GetLabelStr(KIMore);
end;

procedure TMainForm.ActivateControls;
{ Make cotrols visible if required }
begin
  Delayed := TDelayed(TCommonData.ReadInteger(OptionsSection, DelayedKey, 0));
  case Delayed of
    dCheck: DelayedCheck.Visible := True;
    dEdit:  begin
      DelayedEdit.Visible := True;
      DelayedLabel.Visible := True;
    end;
  end;
  if TCommonData.ReadInteger(OptionsSection, QueryReceiverNameKey, 1) = 0
      then begin
    EmpfaengerLabel.Visible := False;
    Empfaenger.Visible := False;
  end;
  if TCommonData.ReadInteger(OptionsSection, QueryUserKey, 1) = 0 then begin
    NutzerLabel.Visible := False;
    Nutzer.Visible := False;
  end;
  if TCommonData.ReadInteger(OptionsSection, QuerySenderNameKey, 1) = 0
      then begin
    NameLabel.Visible := False;
    Name.Visible := False;
    if Nutzer.Visible = False then AbsenderKopf.Visible := False;
  end;
  if TCommonData.ReadInteger(OptionsSection, MoreKey, 0) = 0 then begin
    MoreBtn.Visible := False;
  end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;


procedure TMainForm.MoreBtnClick(Sender: TObject);
begin
  MoreForm := TMoreForm.Create(self);
  MoreForm.ShowModal;
  MoreForm.Free;
  if (MoreStrings <> nil) and (MoreStrings.Count > 0) then
    MoreBtn.Caption := GetLabelStr(KIMore)+'...'
  else
    MoreBtn.Caption := GetLabelStr(KIMore);
end;

end.
